#Autogenerated class


from xml.dom.minidom import parseString

from bioMoby.mobyDataTypes import MobyString
from bioMoby.mobyDataTypes import MobyInteger
from bioMoby.mobyDataTypes import MobyFloat
from Multi_key_value_pair import MobyMulti_key_value_pair
from bioMoby.mobyDataTypes import MobyObject


class MobyBasicGFFSequenceFeature(MobyObject):
    """ Description: An object containing all components necessary to represent a simple GFF-compliant sequence feature (the content is NOT validated against the GFF specification)
        Author: www.illuminae.com
        Contact: markw@illuminae.com
    """
    def __init__(self,namespace="",id="",Reference="",Source="",Method="",Start=0,Stop=0,Score=0.0,Strand="",Frame="",Phase="",Column9_tag_value=[],articleName=""):
        self._articles={"Reference":"reference","Source":"source","Method":"method","Start":"start","Stop":"stop","Score":"score","Strand":"strand","Frame":"frame","Phase":"phase","Column9_tag_value":"column9_tag_value"}
        self.namespace=namespace
        self.id=id
        self.Reference=Reference
        self.Source=Source
        self.Method=Method
        self.Start=Start
        self.Stop=Stop
        self.Score=Score
        self.Strand=Strand
        self.Frame=Frame
        self.Phase=Phase
        self.Column9_tag_value=Column9_tag_value
        self.__prefix__="moby"
        self.__tag__="BasicGFFSequenceFeature"
        self.articleName=articleName


    def fromMoby(self, value):

        """ Load the attributes from an XML string
        """
        from bioMoby.mobyMarshal import MobyUnmarshaller
        doc=value
        if isinstance(value,str):
            doc=parseString(value).firstChild
        um=MobyUnmarshaller()
        self.content=""
        self.namespace=doc.getAttribute("moby:namespace")
        if self.namespace=="":
            self.namespace=doc.getAttribute("namespace")
        self.id=doc.getAttribute("moby:id")
        if self.id=="":
            self.id=doc.getAttribute("id")

        self.articleName=doc.getAttribute("moby:articleName")
        if self.articleName=="":

            self.articleName=doc.getAttribute("articleName")
        self.Column9_tag_value=[]
        for elt in doc.childNodes:
            if elt.nodeType==elt.TEXT_NODE or elt.nodeType==elt.CDATA_SECTION_NODE:
                self.content=self.content+elt.nodeValue
            if elt.nodeName=="CrossReference" or elt.nodeName=="moby:CrossReference":
                self.__cross__=[]
                for ref in elt.childNodes:
                    self.__cross__.append(ref)
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Reference" or elt.getAttribute("moby:articleName")=="Reference"):
                t=MobyString()
                t.fromMoby(elt)
                self.Reference=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Source" or elt.getAttribute("moby:articleName")=="Source"):
                t=MobyString()
                t.fromMoby(elt)
                self.Source=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Method" or elt.getAttribute("moby:articleName")=="Method"):
                t=MobyString()
                t.fromMoby(elt)
                self.Method=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="Integer" or elt.nodeName=="moby:Integer") and (elt.getAttribute("articleName")=="Start" or elt.getAttribute("moby:articleName")=="Start"):
                t=MobyInteger()
                t.fromMoby(elt)
                self.Start=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="Integer" or elt.nodeName=="moby:Integer") and (elt.getAttribute("articleName")=="Stop" or elt.getAttribute("moby:articleName")=="Stop"):
                t=MobyInteger()
                t.fromMoby(elt)
                self.Stop=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="Float" or elt.nodeName=="moby:Float") and (elt.getAttribute("articleName")=="Score" or elt.getAttribute("moby:articleName")=="Score"):
                t=MobyFloat()
                t.fromMoby(elt)
                self.Score=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Strand" or elt.getAttribute("moby:articleName")=="Strand"):
                t=MobyString()
                t.fromMoby(elt)
                self.Strand=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Frame" or elt.getAttribute("moby:articleName")=="Frame"):
                t=MobyString()
                t.fromMoby(elt)
                self.Frame=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="String" or elt.nodeName=="moby:String") and (elt.getAttribute("articleName")=="Phase" or elt.getAttribute("moby:articleName")=="Phase"):
                t=MobyString()
                t.fromMoby(elt)
                self.Phase=t.content
            if elt.nodeType==elt.ELEMENT_NODE and (elt.nodeName=="multi_key_value_pair" or elt.nodeName=="moby:multi_key_value_pair") and (elt.getAttribute("articleName")=="Column9_tag_value" or elt.getAttribute("moby:articleName")=="Column9_tag_value"):
                auxObject=MobyMulti_key_value_pair()
                auxObject.fromMoby(elt)
                self.Column9_tag_value.append(auxObject)